function y = sfb(lo, hi, H, G, p, q, s)
% y = sfb(lo, hi, H, G, p, q, s)
% Synthesis Filter Bank: implements the synthesis filter bank for
% the overcomplete rational-dilation wavelet transform using the FFT.
% 
% See also afb

% up-sample low-pass signal by q
lo2 = zeros(1,length(lo)*q);
lo2(1:q:end) = lo;

% up-sample high-pass signal by s
hi2 = zeros(1,length(hi)*s);
hi2(1:s:end) = hi;

y1 = ifft(fft(lo2).*H);     % low-pass filtering
y1 = y1(1:p:end);           % down-sample LPF output

y2 = ifft(fft(hi2).*G);     % high-pass filtering

y = y1 + y2;                % Add LPF and HPF output signals
