
% Check perfect reconstruction (PR) of radwt for
% a variety of p, q, s, and signal lengths.

clear
addpath radwt_functions_v2          % or use 'radwt_functions_v1'

q = 7;
J = 8;

for p = 1:q-1
    for s = 1:q-1
        redundancy = 1/s * 1/(1-p/q);           % Must be greater than 1
        if redundancy > 1
            for N = 220:230                     % Test signals of various lengths
                x = rand(1,N);                  % Make test signal
                w = radwt(x,J,p,q,s);           % Forward overcomplete rational WT
                y = iradwt(w,p,q,s);            % Inverse overcomplete rational WT
                y = real(y(1:N));               % Reconstructed signal
                e = max(abs(x - y));            % Error should be zero
                disp(e)
            end

        end
    end
end